#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>

#include <things.h>
#include <qptr.h>
#include "qfxptr.h"

void (*_SigStart)(void) = NULL;

typedef struct mitem
{
    short len;
    char chrs[1];
}
MITEM, *PMITEM;

typedef struct
{
    char path[40];
    time_t stamp;
} FAXITEM;

typedef struct
{
    int flag;
    int type;
    short maxitems;
    short current;
    short nitems;
    FAXITEM fdata[1];
} FAX_LIST;

/*
 * Let's just have one of these
 */

char _prog_name[] = "QFAXView \"NT\"";

static char *Stuff = "QFAX Items";

#define STUFF_SIZE 10

#if 0
#include <stdio.h>
#include <stdarg.h>
void Report (char *ctl,...)
{
    va_list va;
    char t[80];

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (0x00010001, -1, t, strlen (t));
}
#endif

static ins_list (PLLIST * pHead, PLLIST pi)
{
    PLLIST pz;

    if ((pz = *pHead) == NULL)
    {
	pi->next = NULL;
    }
    else
    {
        pi->next = pz;
    }
    *pHead = pi;
}
rem_node (PLLIST * pHead, int n)
{
    int i;
    PLLIST pi, pz, pl;

    if (*pHead)
    {
	pl = NULL;
	for (pz = *pHead, i = 0; i < n; i++)
	{
	    pl = pz;
	    pz = pz->next;
	}
	if (pl)
	{
	    pl->next = pz->next;
	}
	else
	{
	    *pHead = pz->next;
	}
	free (pz->item);
	free (pz);
    }
}

static AddFaxMenu (PLLIST * pX, char *q)
{
    PMITEM s;
    PMDEF pm;
    PLLIST pl;
    short n;

    n = strlen(q) + 8;

    s = (PMITEM) malloc (n);
    strcpy (s->chrs, q);
    s->len = strlen (s->chrs);
    pm = (PMDEF) malloc (sizeof (MDEF));
    pm->qtext = (struct QD_text *) s;
    pm->status = WSI_AVBL;
    pm->retval = 0;
    pm->action = NULL,
    pm->skey = 0;
    pm->skey = (*s->chrs == ' ') ? 0 : -1;
    pl = (PLLIST) malloc (sizeof (LLIST));
    pl->item = pm;
    pl->next = NULL;
    ins_list (pX, pl);
}

/*
 * Returns -1  for error
 *          0  for no items
 *         +ve items in list
 */
 
static char * AddElement(char *qt, short elem, char sep)
{
    *qt++ = '0'+ (elem / 10);
    *qt++ = '0'+ (elem % 10);
    *qt++ = sep;
    return qt;    
}

int BuildFaxMenu (PLLIST * pX)
{
    int n = -1;
    THING_LINKAGE *p = NULL;
    long vers = 0;
    int sts;

    sts = (int) sms_uthg (Stuff, -1, -1, NULL, NULL, &vers, &p);
    
    if (sts >= 0)
    {
	char txt[64];
	short i, j, k, m, flen = 0;
        FAX_LIST *f = (FAX_LIST *)p->th_thing;

	if (n = f->nitems)
        {	
            j = f->current;
	    for (i = 0; i < n; i++, j++)
            {
                j = j % n;
                if((k = strlen(f->fdata[j].path)) > flen)
                {
                    flen = k;
                }
            }

            j = f->current;
	    for (i = 0; i < n; i++, j++)
	    {
                time_t t1;
                char *s, *fillc;
		char c, ttxt[32];
                struct tm *tm;
                s = txt;

                j = j % n;
                t1 = TIME_QL_UNIX(f->fdata[j].stamp);
                tm = localtime(&t1);
                m = n - i- 1;
    	        if (m < 10)
	        {
		    c = m + 48;
	        }
	        else if (m > 9 && m < 36)
	        {
		    c = m + 55;
	        }
	        else
	        {
		    c = ' ';
	        }

                *s++ = c;
                *s++ = ' ';
                strcpy(s, f->fdata[j].path);
                s += strlen(s);
                fillc = txt + (3 + flen);
                while(s < fillc)
                {
                    *s++ = ' ';
                }

                s = AddElement(s, tm->tm_mday,'/');
                s = AddElement(s, (tm->tm_mon + 1),'/');
                s = AddElement(s, tm->tm_year % 100,' ');
                s = AddElement(s, tm->tm_hour,':');
                s = AddElement(s, tm->tm_min,':');
                s = AddElement(s, tm->tm_sec,'\0');
		AddFaxMenu (pX, txt);
	    }
	}
	sms_fthg (Stuff, -1, NULL, 0, NULL, NULL);
    }
    return n;
}

FreeFaxList (PLLIST *pL)
{
    PLLIST p;

    for (p = *pL; p;)
    {
	PMITEM s;
	PMDEF pm;
	PLLIST pd;

	pd = p;
	p = p->next;
	pm = (PMDEF) pd->item;
	s = (PMITEM) pm->qtext;
	free (s);
	free (pm);
	free (pd);
    }
    *pL = NULL;
}

int main(int ac, char **av)
{
    int opt;
    PLLIST RFxList = NULL;
    short RFxNum;
    int n;
    short nc, mono;
    char *sp;
    
    sp = *(av + 1);
    nc = *((short *) (sp));
    sp += 2 + nc * 4;
    mono = *((short *) sp);

    if((RFxNum = BuildFaxMenu(&RFxList)) > 0)
    {
        n = menu(&RFxList, RFxNum, mono);
        if(n >= 0)
        {
            short i;
            PLLIST p;
            for (p = RFxList, i = 0; i < n; p = p->next,i++)
                ;
            
            {
    	        PMITEM s;
	        PMDEF pm;
                char *q;
                char str[64];
            
 	        pm = (PMDEF) p->item;
	        s = (PMITEM) pm->qtext;

	        strcpy(str, s->chrs+2);
                if(q = strchr(str, ' '))
                {
                    *q = '\0';
                }
		hk_stbuf(str);
            }
        }
    }
    return 0;
}
int (*_Cstart) (int, char **) = main;
