#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#ifndef __NT__
#include <sys/param.h>
#else
typedef unsigned short ushort;
typedef unsigned long ulong;
#define MAXPATHLEN PATH_MAX
#endif

#include "qfaxparse.h"

#if BYTE_ORDER == LITTLE_ENDIAN

void HeaderEndianise(QFAXHEADER *h)
{
    h->title = LG(h->title);
    h->version = LG(h->version);
    h->width = SH(h->width);
    h->page = SH(h->page);
    h->pagemax = SH(h->pagemax);
    h->stamp = LG(h->stamp);
    h->hint = LG(h->hint);
    h->offset = LG(h->offset);
}

void OffrecEndianise(OFFREC *o)
{
    o->off = LG(o->off);
    o->pageno = SH(o->pageno);
    o->code = SH(o->code);
    o->res = SH(o->res);
}
#endif

#ifndef QDOS

FILE *lopen(const char *s, const char *mode)
{
    FILE *fp;
#ifdef __NT__
    char fnam[256];
#endif
    
    if(*s == '~')
    {
#ifndef __NT__
	char *p = (char *)alloca(MAXPATHLEN);
#else
        char *p = fnam;
#endif
	strcpy(p, getenv("HOME"));
	strcat(p, s + 1);
	s = p;
    }
    
    fp = fopen(s, mode);
    if(fp == NULL)
    {
	char pname[512];
	char *pf;
	
	if((pf = getenv("HOME")))
	{
	    short n;
	    
	    strcpy(pname, pf);
	    n = strlen(pname);
	    if(*(pname + n-1) != '/' 
#ifdef __NT__
                && *(pname + n-1) != '\\'
#endif
                )
	    {
		*(pname + n) = '/';
		*(pname + n+1) = '\0';
	    }
	    strcat(pname, s);
	    fp = fopen(pname, mode);
	}
    }
    return fp;
}
#endif
#ifdef __NT__
char *stpcpy(char *d, const char *s) 
{
    while(*d++ = *s++)
        ;
    return d-1;
}
#endif

#ifdef TEST
main(int ac, char **av)
{
    FILE *fp = lopen("~/.qfax.phone", "r");
    
    return 0;
}
#endif


