#ifndef _QFV_
#define _QFV_H
#ifdef __NT__
 typedef unsigned short ushort;
 typedef unsigned long ulong;
#endif

#include "qheader.h"
#include "qfaxparse.h"

typedef struct
{
    char *scan;                     /* Scan image */
    char  FileName[40];             /* File name */
    char  PrtName[40];              /* Print name/device */
    FILE  *fp;
    void  *preq;
    long fbytes;
    short interact;
    short specific;
    short xline;                    /*  */
    XPL *xpl;                       /* Printer flag */
    short pabort;
    short ysize;
    short compress;
    short paper;
    short buck;                     /* Stops here !!! */
    short maxwid;
    long  maxmem;
    QFAXHEADER qh;
} VIEWPORT, *PVIEWPORT;

extern PVIEWPORT pv;
extern short pixwid[];
extern short pixhgt[];

#define HPPCL   0
#define EPSON24 1
#define EPSON09 2
#define PS      3
#define GIF     103
#define QTIFFR  105
#define QTIFFP  106
#define QTIFFZ  107

#define PAPER_A4    0
#define PAPER_LTR   1
#define PAPER_LGL   2

typedef unsigned char byte;
typedef unsigned short word;
#ifndef __linux__
typedef unsigned int uint;
#endif

extern char *SetRequester(void *, void *);
extern int CheckPrAbort(void *);
extern void ClearRequester(void *);
extern void ClosePrt(int);

#define SLACK 20

#ifdef QDOS
#undef FAST
#ifdef FAST
#define bzero   _bzero
#define memset  _memset
#define bcopy   _bcopy
#ifdef movmem
# undef movmem
#endif
#define movmem  _movmem
#define memcpy  _memcpy
#define memmove _memmove
#endif

#include <memory.h>
#define clrmem(p1,p2) bzero((char *)p1,p2)
#endif

extern void Report (char *,...);
extern void Warning (char *,...);

#ifdef __linux__
#define clrmem(p1,p2) bzero(p1,p2)
#endif

#ifdef __NT__
# define clrmem(p1,p2) memset(p1, 0, p2)
# define bzero(p1,p2) memset(p1, 0, p2)
#endif

#endif /*QFV_H*/
