#include <stdio.h>
#include <stdlib.h>

#define VR_NORMAL	0
#define VR_FINE		1

#define BR_2400    	0
#define BR_4800    	1
#define BR_7200    	2
#define BR_9600    	3
#define BR_12000    	4
#define BR_14400    	5

#define WD_1728		0
#define WD_2048		1
#define WD_2432		2

#define LN_A4		0
#define LN_B4		1
#define LN_UNLIMITED	2

#define DF_1DHUFFMAN 	0
#define DF_2DMREAD	1
#define DF_2DUNCOMP	2

typedef struct
{
    int vr;
    int br;
    int wd;
    int ln;
    int df;
    int ec;
    int bf;
    int st;
}
T30PARAMS, *PT30PARAMS;

char *t30_vr_string (PT30PARAMS p)
{
    switch (p->vr)
    {
	case VR_NORMAL:
	    return ("normal");
	case VR_FINE:
	    return ("fine");
	default:
	    return ("unknown");
    }
}

char *t30_br_string (PT30PARAMS p)
{
    switch (p->br)
    {
	case BR_2400:
	    return ("2400");
	case BR_4800:
	    return ("4800");
	case BR_7200:
	    return ("7200");
	case BR_9600:
	    return ("9600");
	case BR_12000:
	    return ("12000");
	case BR_14400:
	    return ("14400");
	default:
	    {
		static char txt[32];
		sprintf (txt, "Unknown %d", p->br);
		return (txt);
	    }
    }
}

char *t30_wd_string (PT30PARAMS p)
{
    switch (p->wd)
    {
	case WD_1728:
	    return ("215");
	case WD_2048:
	    return ("255");
	case WD_2432:
	    return ("303");
	default:
	    return ("unknown");
    }
}

char *t30_ln_string (PT30PARAMS p)
{
    switch (p->ln)
    {
	case LN_A4:
	    return ("A4");
	case LN_B4:
	    return ("B4");
	case LN_UNLIMITED:
	    return ("unlimited");
	default:
	    return ("unknown");
    }
}

char *t30_df_string (PT30PARAMS p)
{
    switch (p->df)
    {
	case DF_1DHUFFMAN:
	    return ("1D huffman");
	case DF_2DMREAD:
	    return ("2D read");
	case DF_2DUNCOMP:
	    return ("2D uncompressed");
	default:
	    return ("unknown");
    }
}
