#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>
#include <things.h>

typedef struct
{
    char path[40];
    time_t stamp;
} FAXITEM;

typedef struct
{
    int  flag;
    int  type;
    short maxitems;
    short current;
    short nitems;
    FAXITEM fdata[1];
} FAX_LIST;

static char *Stuff = "QFAX Items";
#define STUFF_SIZE 10
 
void AddFaxList (char *path, time_t tim, char *fnam)
{
    THING_LINKAGE *p = NULL;    
    long vers = 0;
    int sts;

    sts = (int) sms_uthg(Stuff, -1, -1, NULL, NULL, &vers, &p);
    if(sts > 0)
    {
        short pos;
        FAX_LIST *f = (FAX_LIST *) sts;

        _super();
        pos = (f->current + 1) % f->maxitems;
        if(f->nitems < f->maxitems)
        {
            f->nitems++;
        }
        strcpy(f->fdata[f->current].path, path);
        f->fdata[f->current].stamp = tim;
        f->current = pos;
        _user();    
        if(fnam)
        {
            int chid;
            short i;

            /* Do this a la QDOS for minimal size in other apps. */
            
            if((chid = io_open(fnam, 3)) > 0)
            {
                /* for convenience of loading, the list is saved
                 * in chronlogical order (current == nitems)
		 */
                io_sstrg (chid, -1, f, (2*sizeof(int) + sizeof(short)));
                io_sstrg (chid, -1, &f->nitems, sizeof(short));
                io_sstrg (chid, -1, &f->nitems, sizeof(short));

        	for (i = 0; i < f->nitems; i++, pos++)
	        {
                    pos = pos % f->nitems;
                    io_sstrg (chid, -1, &(f->fdata[pos]), sizeof(FAXITEM));
                }
                io_close(chid);
            }
        }
        sms_fthg (Stuff, -1, NULL, 0, NULL, NULL);
    }
}

