#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <qdos.h>

int SpawnCmd (char *, char *);
/*
 * SJOB structure defines parameters for spawned job.
 */

typedef struct
{
    char *FileName;
    char *ComStr;
    char *InFile;
    int inflag;
    char *OuFile;
    int ouid;
    int JobId;
    int serr;
    unsigned char Prio;
    unsigned char Wait;
} SJOB, *PSJOB;

extern int spawn(SJOB *);
extern char * GetScriptLog(void);
extern void vStartMBJob (char *, char *, char *, int, int,...);
extern short minnie;

int SpawnScript(char *sname, short timo, char *cmd)
{
    SJOB s;
    s.FileName = sname;
    s.ComStr = cmd;
    s.InFile = (char *) -1;
    s.inflag = -1;
    s.OuFile = GetScriptLog();
    s.ouid = 0;
    s.serr = 0;
    s.Wait = timo;
    s.Prio = 1;
    s.JobId = -1;
    return spawn(&s);
}

int RunScript(char *QName, short timo, char *cmd)
{
    struct qdirect qd;
    int rv = -1;
    if(qstat(QName, &qd) == 0)
    {
       if(qd.d_type == QF_PROG_TYPE)
       {
           if(SpawnScript(QName, 0, cmd) == 0)
           {
                rv = 0;
            }
       }
       else if(minnie)
       {
           char *p;
           if((p = strstr(QName, "_bas")) && *(p+4) == 0)
           {
               vStartMBJob ("QTPI Script", QName, cmd, timo, -1);
               rv = 0;
            }
        }
    }
}

static char * FullName(char *name, char *myname)
{
    char *p;
    int fnd;
    
    if(isdirdev (name) == 0)
    {
        if(getcpd(myname, 32))
        {
            p = strcat(myname, name);
        }
        if(access(p, 1) != 0)
        {
            if(getcwd(myname, 32))
            {
                p = strcat(myname, name);
            }
            else
            {
                p = name;
            }
        }
    }
    else
    {
        p = name;
    }
    return p;
}

int SpawnCmd (char *cmd, char *opts)
{
    extern spawn(PSJOB);
    char ExeName[64];
    SJOB s;
    int xstat;
    int IPipe = -1;
    int OPipe;
    
/*
 *  This is a (cheap) dummy to keep everything happy
 *  There is no universal NULL device on QDOS
 */
    OPipe = io_open ("pipe_16", 0);

    memset (&s, '\0', sizeof (SJOB));

    s.FileName = FullName(stpblk(cmd), ExeName);

    s.InFile = "pipe_0";
    s.inflag = OPipe;
    s.ComStr = *opts ? opts : NULL;
    s.OuFile = "pipe_16";
    s.serr = -1;
    s.Wait = 0;
    s.Prio = 2;
    s.JobId = 0;

    if ((xstat = spawn (&s)) == 0)
    {
        IPipe = io_open ("pipe_0", s.ouid);
    }
    io_close(IPipe);
    io_close(OPipe);
    return IPipe;
}
