#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <qdos.h>

#ifndef TEST
#include "qfax.h"
#include "qfaxparse.h"
#else
typedef struct
{
    char serdev[40];
    int baud;
} FAXDATA;
#endif

extern FAXDATA qd;

static int pChan = 0;
static char rbuf[512];
static short ibuf = 0;
static char *tp = rbuf;

#ifdef TEST
#define msg(p1,p2) puts(p2)
#endif

void tty_chan (int chan)
{
    pChan = chan;
#if 0
    if(qd.baud)
        mt_baud(qd.baud);
#endif
}

long tty_open (short flag)
{
    
    if(flag == 0)
    {
	return (pChan = getchid (0));
    }
    if((pChan = io_open(qd.serdev, 1)) < 0)
    {
	msg (0, "can't open fax modem device");
	exit (-9);
    }
    if(qd.baud)
        mt_baud(qd.baud);
    return (pChan);
}

void tty_close (void)
{
    if(pChan)
    {
        io_close(pChan);
    }
    pChan = 0;
}

SRead(char *buf, int nchar, int timeout)
{
    int m,n;
    int t;

    n = 0;
    
    while(ibuf && nchar)
    {
	ibuf--;
	nchar--;
	*buf++ = *tp++;
	n++;
    }
    
    if(nchar)
    {
	if(timeout > 0)
	{
	    t = timeout * 5;
	}
	else
	{
	    t = timeout;
	}

        m = io_fstrg(pChan, t, buf, nchar);

	if(m > 0)
	{
	    n += m;
	    if(n == nchar)
	    {
		ibuf = io_fstrg(pChan, 0, (tp = rbuf), sizeof(rbuf));
		if(ibuf < 0) ibuf = 0;
#ifdef TEST
		else
		    printf("Fetch = %d\n", ibuf);
#endif
	    }
	}
    }
    return (n > 0) ? n : 0;
}
SWrite(char *buf, int nchar)
{
    int i;
    int ns;
    char *p;
    char s;

    if(nchar <= 0)
    {
        nchar = strlen(buf);
    }

    for(i = nchar, p = buf; i; )
    {
        if(i > 1024)
        {
            ns = 1024;
        }
        else
        {
            ns = i;
        }
        i -= ns;
        io_sstrg(pChan, -1, p, ns);
        p += ns;
    }

    return nchar;
}

#ifdef TEST
FAXDATA qd;
main(int ac, char **av)
{
    int n;
    int i;
    char buf[16];
    
    strcpy(qd.serdev, av[1]);
    qd.baud = 0;
    
    tty_open(1);

    while(fputs(">", stdout), gets(buf))
    {
        n = SRead(buf, 20, 50);
	printf("read %d\n", n);
    }
}
#endif
