#include <stdio.h>
#include <memory.h>

#ifndef TRUE
# define TRUE 1
#endif 
#ifndef FALSE
# define FALSE 0
#endif 

#include "qfaxparse.h"
#include "qheader.h"

#define Local static
#define Prototype extern

extern int decode_fax2 (int *, int, short, short *);
#ifdef QDOS
extern FILE * FindFax(short);
#else
extern int FindFax(void);
#endif
extern void CloseFaxFile(void);
extern void FlipMap(unsigned char *, int);

typedef struct
{
    int chan;                       /* QDOS channel */
    char *scan;                     /* Scan image */
    short mag;                      /* Magnification */
    short offset;                   /* X offset */
    short yp;                       /*  */
    short xline;                    /*  */
    short iline;                    /*  */
    short tline;                    /*  */
    short tos;                      /* Fax line at Top of screen */
    short ht;                       /* Screen height in fax units */
    short aspect;                   /* Aspect counter */
    short xsize;                    /* x size of window */
    short ysize;                    /* y size of window */
    short fct;                      /* scaling factor */
    short maxbyte;                  /* bytes to display */
    short white;                    /* white overwrite required */
    char  FileName[64];             /* File name */
    char  PrtName[40];              /* Print name/device */
    XPL *xpl;                       /* Printer flag */
    char  DoAct;                    /* Action */
    char  pabort;                   /* printer abort */
    QFAXHEADER qh;                  /* Header for this fax */
    int eon;                        /* Time to decode */
    void *preq;                     /* Address of abort job */
    short specific;                 /* Printer specific */
    short compress;                 /* compression */
    FILE *fp;
    short F_pix;
    short F_char;
    short F_page;
    long  fbytes;
    short paper;
    short FaxPage;
    short buck;                     /* Stops here :-) */
    long  maxmem;
    short maxwid;
    short PrtFlag;
    short selpg;
} VIEWPORT, *PVIEWPORT;

#define HPPCL       0
#define EPSON24     1
#define EPSON09     2
#define PS          3

extern PVIEWPORT pv;
extern FAXDATA qd;

#ifdef QDOS

typedef struct
{
    struct QD_text *qtext;
    char skey;
    unsigned char status;
    int retval;
    struct WM_action *action;
} MDEF, *PMDEF;

typedef struct
{
    void *next;
    void *item;
}
LLIST, *PLLIST;

#include <qptr.h>
#include "qfv-protos.h"
#endif

/* These define max screen sizes DON'T CHANGE THEM
 * (Fax only)
 */

#define MAXXFAX  (2432+12)
#define MAXYFAX  (3218+32)

#define I_LOAD  0
#define I_PNEXT 1
#define I_PPREV 2
#define I_GOTO  3
#define I_LAST  4
#define I_REV   5
#define I_PRINT 6
#define I_SETUP 7
#define I_INFO  8
#define I_FLIP  9

#define M_LOAD  (1 << I_LOAD)
#define M_PNEXT (1 << I_PNEXT)
#define M_PPREV (1 << I_PPREV)
#define M_GOTO  (1 << I_GOTO)
#define M_LAST  (1 << I_LAST)
#define M_REV   (1 << I_REV)
#define M_PRINT (1 << I_PRINT)
#define M_SETUP (1 << I_SETUP)
#define M_INFO  (1 << I_INFO)
#define M_FLIP  (1 << I_FLIP)

#define AWXOFF 4
#define AWYOFF 32

#define XBARS 8
#define YBARS 6

extern short pixwid[];
extern short pixhgt[];
extern char *SetRequester(void *, void *);
extern int CheckPrAbort(void *);
extern void ClearRequester(void *);
#ifdef QDOS
#define clrmem(p1,p2) bzero((char *)p1, p2)
#endif
#define PAPER_A4    0
#define PAPER_LTR   1
#define PAPER_LGL   2

#define SLACK 20
#define BLANK 8
extern void Report (char *,...);
extern void Warning (char *,...);

typedef unsigned char byte;
#ifdef __linux__
ushort swapword (ushort val);
ulong swaplong (ulong val);
#else
#define swapword(v) (v)
#define swaplong(v) (v)
#endif

