#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdarg.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <unistd.h>

#include "text2g3.h"

struct WINDOWDEF _condetails = {6, 1, 0, 6, 364, 75, 60, 60};
long (*_cmdchannels) (long) = NULL;
/*long (*_stackchannels) (long) = NULL;*/
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
int (*_conread)  (struct UFB *, void *, unsigned int) = NULL;
int (*_conwrite)  (struct UFB *, void *, unsigned int) = NULL;
char _copyright[]           =   "QFAX 94";
char _prog_name[]           =   "text2g3";
char _version[]             =   FAXVERS;

static long lit_reset (struct WM_wwork *, short);
static long lit_event (struct WM_wwork *, struct WM_litm *);

static long MMOVE (struct WM_wwork *, struct WM_litm *);
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);

static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    4		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    2		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

#define winX     360
#define winY     60

static QD_TEXTI (END, "ESC");
static QD_TEXTI (TITLE, "QFAX-text2g3");

static int   mpid = 0;
                        
static struct WM_info info[ninfo + 1] =
{
    {72, 10, 6, 0, 0, 0, 2, 0, 0, &TITLE},
    {-1}
};


static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {winX, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0, 			/* flag                 no clear + shadow */
     0, 7, 84,  		/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {84, 10,			/* xsize, ysize         size */
     (winX-84)/2+4, 2,		/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     info},			/* *pobj                pointer to object list */
     {22,10,2,2,0,0,0,7,NULL},
     {22,10, winX-24,2, 0, 0, 0, 7, NULL},
    {-1}			/* end of array */
};

extern struct WM_sprite wm_sprite_move;

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {22, 10,   2, 2, 0, 0, 2, K_MOVE,   &wm_sprite_move,    0, &mmove},
    {22, 10, winX-24, 2, 0, 0, 0, K_CANCEL, &END,           1, &aexit},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    winX, winY,			/* xsize, ysize         size */
    0, 14,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    0, 0, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};

static struct WM_appl appl[nappl + 1] =
{
    &aw0, NULL
};


static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    winX, winY+14,      	/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    2+NO_WCLEAR,		/* flag                 no clear + shadow */
    1, 4, 7,    		/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    1, appl			/* nappl  *pappl        appl winds */
};


static struct fmsg
{
    char *prompt;
    short xp;
    short yp;
    short clr;
} f[] = {   {"File  : ", 0, 0, 1},
            {"Format: ", 0, 1, 0}, {"Size : ", 36, 1, 1},
            {"Page  : ", 0, 2, 0}, {"Line : ", 36, 2, 0},
            {"Extra : ", 0, 3, 1},
            {"Msg   : ", 0, 4, 1}
        };
 
#define NMSG (sizeof(f)/sizeof(struct fmsg))

static chanid_t chid = 0;
static short xflg = 0, tflg = 0;

extern jcall (void (*)( ), char *, int, int, int,...);

static long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;
    return wm_ldraw (wwk, -1);
}

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    mt_frjob(mpid, 0);
    exit (0);
}

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{
    tflg++;
    if(wst->evnt & PT_KYPRS || wst->evnt & PT_KYSTK || wst->evnt & PT_KEYUP)
    {
        xflg = 1;
    }
    return 50;
}


static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    wm_swdef (wwk, apw, chid);
    return 0;
}

static long MMOVE (struct WM_wwork *wwk, struct WM_litm *li)
{
    short dx, dy;

    if(mpid)
    {
        mt_susjb(mpid, -1, NULL);
    }

    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */

    ADRAW(wwk, &aw0);

    if(mpid)
    {
        mt_reljb(mpid);
    }

    return lit_reset (wwk, li->item);
}

void PTRWindow(void)
{
    while(1)
    {
	wm_rptr (&ww);
    }
}

void InitWindow(short noptr, short mono)
{
    short i;
    short ink;
    
    ww.chid = fgetchid (stdin);
    iop_outl(ww.chid, -1, 0, 0, 0, (short *)&ww.xsize);
    if(mono)
    {
        ink = 7;
        info[0].attr.t.ink = 0;
        infw[0].papr = 127;
        ww.borc = 7;
    }
    else
    {
        ink = 4;
    }
    
    if ((noptr == 0) && wm_findv (ww.chid))
    {
        chid = io_open("scr", 0);
        mpid = getpid();
        ws.wwork = &ww;		/* set cross reference */
        wm_prpos (&ww, -1, -1);
        wm_wdraw (&ww);
        jcall(PTRWindow, "G3-Ptr", 1, 2048, 0);
        mt_prior(-1, 10);
    }
    else
    {
        chid = fgetchid(stdout);
        consetup_title(chid, &_condetails);
    }
    if(chid)
    {
        sd_setin(chid, -1, ink);
        for(i = 0; i < NMSG; i++)
        {
            if(sd_pos(chid, -1, f[i].xp, f[i].yp) == 0)
            {
                io_sstrg(chid, -1, f[i].prompt, strlen(f[i].prompt));
            }
        }
        sd_setin(chid, -1, 7);
    }
}
void Update (short act, char *fmt,...)
{
    char txt[128];

    va_list ap;
    va_start (ap, fmt);
    vsprintf (txt, fmt, ap);
    if(chid)
    {
        if(sd_pos(chid, 0, f[act].xp + strlen(f[act].prompt), f[act].yp) == 0)
        {
            if(io_sstrg(chid, 0, txt, strlen(txt)) > 0 && f[act].clr)
            {
                sd_clrrt(chid, 0);
            }
        }
    }

    if(!chid || getchid(0) != getchid(1))
    {
        fputs(f[act].prompt, stderr);        
        fputs(txt, stderr);
        fputc('\n', stderr);
        fflush(stderr);
    }
    va_end (ap);
}
void MyExit(short wait, int n)
{
    static const char p[] = "Press a key to exit";    

    if(!wait)
    {
        extern char * _endmsg;
        _endmsg = NULL;
    }
    else
    {
        if(chid && mpid)
        {
            short tcnt;
            _endmsg = NULL;
            io_sstrg(chid, 0, p, sizeof(p)-1);
            xflg = 0;
            for (tcnt = 0; ((xflg == 0) && (tcnt < 10)); tcnt++)
            {
                sleep(1);
            }
        }
    }
    exit(n);        
}
#ifdef TEST
main(int ac, char **av)
{
    int i = 0, j = 0, k = 0;
    
    InitWindow();
    Update(U_IFILE,"text2g3_test");
    for(i = 0; ;i++)
    {
        char txt[32];
        k++;
        sprintf(txt, "%5d", k);
        Update(U_LINE, txt);
        if(i == 0 || k == 66)
        {
            k = 0;
            j++;
            sprintf(txt, "%5d", j);
            Update(U_PAGE, txt);
        }
        sleep(1);
    }
}
#endif
