#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <time.h>

#include "qfv.h"
#include "qfpp.h"
#include "qfaxparse.h"

static VIEWPORT vp = {0};
PVIEWPORT pv = &vp;

static short SuperW=WIDTH_SUPER, SuperH = HEIGHT_SUPER;
static short wbscn = 1;
static short scale = 1;
static short uselast = 0;
char *RedMap = NULL;
static char *MaxMap = NULL;
static struct FileRequester *fr = NULL;
static short frptr = 0;
static int eon;
static short FaxPage;
static short badlines;
static short skipbad = 1;

static short CheckFile(void)
{
    short can_do = 0;
    if(FaxPage > 0)
    {
        can_do |= M_PREV;
    }
    if(FaxPage < pv->qh.pagemax - 1)
    {
        can_do |= M_NEXT;
    }    
    return can_do;
}

static void GetFaxPage(short iact)
{
    if(iact == MU_PREV)
    {
        FaxPage--;
    }
    else
    {
        FaxPage++;
    }
    LoadFax(0);
}

static void GetNextFile()
{
    frptr++;
    LoadFrFile();
}

void ShowFax()
{

}

static void LoadFax(short lflag)
{
    static UWORD flag = 0;
 
    short i;
    
    fact = (M_NEW | M_ARR);
    
    if(frptr < (fr->rf_NumArgs - 1))
    {
        fact |= M_OPEN;
    }

    if(*vp.FileName)
    {
        short er;
        struct Requester myreq;
        int t1, rv = -1;
        
        if(flag)
        {
            SetRast(Win->RPort, 0);
            ClearBitMaps();
        }
        
        if (lflag)
        {
            if(FindFax(2))
            {
                unsigned long nh = 0, nw = 0;
                short res = 0;

                FaxPage = 0;
                
                if(RedMap)
                {
                    res = 1;
                }
            
                if((pixwid[pv->qh.width] >> res) != SuperW)
                {
                    nw = SuperW = (pixwid[pv->qh.width] >> res);
                }    

                if((pixhgt[pv->qh.page] >> res) != SuperH)
                {
                    nh = SuperH = (pixhgt[pv->qh.page] >> res);
                }    
                if(nh || nw)
                {
                    bigBitMap->BytesPerRow = SuperW >> 3;
                    bigBitMap->Rows = SuperH;
                    WindowLimits(Win, 0, 0, nw, nh);
                    InitMap();
                }
                if(pv->qh.version > QFAXNEWFMT && pv->qh.hint)
                {
                    pv->buck = (6 + (pv->qh.hint << (1-pv->qh.resolution)));
		}
	    }
	    else
	    {
                /* Sort out error */
                /* Report("Fubar"); */
	    }
	}

        rv = decode_fax2 (NULL, FaxPage, skipbad, &badlines);

        if(rv == 0)
        {
            fact |= (M_PRINT | M_INFO);
	    ShowFax();
            fact |= CheckFile();                
        }
    }

    for(i = I_OPEN; i < I_LAST; i++)
    {
        if(fact & (1 << i))
        {
            OnMenu(Win, FULLMENUNUM(0, i, 0));
        }
        else
        {
            OffMenu(Win, FULLMENUNUM(0, i, 0));
        }
    }
}

static void ClearBitMaps()
{
    int bmx;
        
    bmx = SuperW * SuperH >> 3;
    pv->maxmem = bmx;
    
    if(RedMap)
    {
        bzero (RedMap, bmx);
        bmx = bmx << 2;
        if(MaxMap)
        {
            bzero (MaxMap, bmx);
        }
    }
    else if(MaxMap)
    {
        bzero (MaxMap, bmx);
    }
}


static void DumpIt()
{
    struct TagItem ti[] =
    {
        {SYS_Input, NULL},
        {SYS_Output, NULL},
        {SYS_Asynch, FALSE},
        {TAG_DONE}
    };
    QFVREC q;
    char command[80];

    sprintf(command,"printfax -Z %p", &q);

    q.scan = pv->scan;
    q.xline = pv->xline;
    q.qh = pv->qh;
    q.win = Win;
    strcpy(q.file, pv->FileName);
    
    ti[0].ti_Data = Open ("NIL:", MODE_OLDFILE);
    ti[1].ti_Data = Open ("NIL:", MODE_NEWFILE);
    System (command, ti);
}

static char *vr_string (short vr)
{
    switch (vr)
    {
	case VR_NORMAL:
	    return ("normal");
	case VR_FINE:
	    return ("fine");
	default:
	    return ("unknown");
    }
}

static char *df_string (short df)
{
    switch (df)
    {
	case DF_1DHUFFMAN:
	    return ("1D huffman");
	case DF_2DMREAD:
	    return ("2D read");
	case DF_2DUNCOMP:
	    return ("2D uncompressed");
	default:
	    return ("unknown");
    }
}
static void ShowInfo(void)
{
    time_t ti;
    
    if(pv->xline)
    {
        short nlin, xlin,lsb;
        lsb = 0;
        if(pv->qh.version > QFAXFLSB)
        {
            lsb = pv->qh.lsb;
        }

        nlin = pv->xline;
        xlin = pixhgt[pv->qh.page];

        Report("TSI/CSI    : %.23s\n"
               "Date       : %24.24s\n"
               "Resolution : %s\n"
               "Coding     : %s (%lcsb)\n"
               "Lines      : %4ld (/%4ld) %ld.%ld (%ld bad)\n"
               "Pages      : %ld/%ld\n",
            pv->qh.tsi,
            ctime((long *)&(ti)),
            vr_string(pv->qh.resolution), 
            df_string(pv->qh.coding), lsb ? 'l' : 'm',
            nlin, xlin, eon /50, eon % 50, badlines,
            1+FaxPage, pv->qh.pagemax);
    }
    else
    {
        Report("Nothing loaded");
    }
}


#if 0
                        if(menuNum == 0)
                        {
                            switch(itemNum)
                            {
                                case MU_NEW:
                                    frptr = 0;
                                    if(AslRequest (fr, 0L))
                                    {
                                        LoadFrFile();
                                        LoadFax(1);
                                    }
                                    break;
                                case MU_ARR:
                                    frptr = 0;
                                    {
                                        char *p;
                                        if(p = GetThingList ("qfax:QFAXThing", screen, vinfo))
                                        {
                                            strcpy(vp.FileName, p);
                                            LoadFax(1);
                                        }
                                    }
                                    break;
                                case MU_OPEN:
                                    GetNextFile();
                                    LoadFax(1);
                                    break;
                                case MU_NEXT:
                                case MU_PREV:
                                    GetFaxPage(itemNum);
                                    break;
                                case MU_PRINT:
                                    DumpIt();  
                                    break;
                                case MU_INFO:
                                    ShowInfo();
                                    break;
                                case MU_FLIP:
                                {
                                    int n;
                                    n = pv->xline+1;
                                    if(n > SuperH)
                                    {
                                        n = SuperH;
                                    }
                                    if(RedMap)
                                    {
                                        FlipMap (RedMap, (n /2 + 1)*bigBitMap->BytesPerRow);
                                    }
                                    else if(MaxMap)
                                    {
                                        FlipMap (MaxMap,  n*bigBitMap->BytesPerRow);
                                    }
                                    ShowFax();
        			}
                                    break;
                                case MU_QUIT:
                                    flag = 0;
                                    break;
#endif







