
typedef struct
{
    Pixmap pixmap;
    Dimension width;
    Dimension height;
    short curx;
    short cury;
    XImage *xi;
    GC sgc;
    GC pgc;
    void *data[2];
    int size[2];
    short vres;
    short fn;
} BITMAP;

#define MU_LOAD   0
#define MU_PRINT  (MU_LOAD+1)
#define MU_PRINTX (MU_PRINT+1)
#define MU_NPAGE  (MU_PRINTX+1)
#define MU_PPAGE  (MU_NPAGE+1)
#define MU_NFAX   (MU_PPAGE+1)
#define MU_PFAX   (MU_NFAX+1)
#define MU_FLIP   (MU_PFAX+1)
#define MU_QUIT   (MU_FLIP+1)
#define MU_ITEMS  MU_QUIT+1

#define M_LOAD    (1 << MU_LOAD)
#define M_PRINT   (1 << MU_PRINT)
#define M_PRINTX  (1 << MU_PRINTX)
#define M_NPAGE   (1 << MU_NPAGE)
#define M_PPAGE   (1 << MU_PPAGE)
#define M_NFAX    (1 << MU_NFAX)
#define M_PFAX    (1 << MU_PFAX)
#define M_FLIP    (1 << MU_FLIP)
#define M_QUIT    (1 << MU_QUIT)

#define M1ITEMS MU_ITEMS

#define DEFXSIZE 920
#define DEFYSIZE 640

#define WIDTH_SUPER     (2432)
#define HEIGHT_SUPER    (3218)
#define MEMSIZ       ((WIDTH_SUPER * HEIGHT_SUPER) >> 3)

extern short mineop;

void Report (char *ctl,...);
void Warning (char *ctl,...);
void GetFaxPage(FD_fax *f, BITMAP *b, short iact);
void SetMenu (FD_fax *f, short fact);
void SetLabel(char *);
void FlipMap(void *, int);
void Invert(FD_fax *f, BITMAP *b);
void ResetAll(FD_fax *f, BITMAP *b);
void ClosePrt(int);
int PrintPage(int, char *);
void DoPrint(FD_fax *f, BITMAP *b,short);
void PrevPage(FD_fax *f, BITMAP *b);
void PrevFax(FD_fax *f, BITMAP *b);
void NextPage(FD_fax *f, BITMAP *b);
void NextFax(FD_fax *f, BITMAP *b);
void LoadFax(FD_fax *f, BITMAP *b, short);
int decode_fax2 (int *, int, short, short *);
FILE * FindFax(short);
void FreeBitMap (FD_fax *f, BITMAP *b, short flag);
int init_xfax (FD_fax *f, int argc, char **argv);
void GetBitMap (FD_fax *f, BITMAP *b, char *fnam);
void DrawImage(FD_fax *f);
void RefreshImage(FD_fax *f);
void IniPrt(void *);

#define CANVID(p) fl_get_canvas_id(p)



